E-MailRelay

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
G::PidFile Class Reference

A class for creating pid files. More...

`#include <gpidfile.h>`

## Public Member Functions
| PidFile (const Path &pid_file_path)
| Constructor. More...
| PidFile ()
| Default constructor. More...
void | init (const Path &pid_file_path)
| Used after default construction to make the object active. More...
| ~PidFile ()
| Destructor. Calls cleanup() to delete the file.
void | commit ()
| Creates the file and installs signal handlers to cleanup() the file on abnormal process termination. More...
bool | committed () const
| Returns true if commit() has been called with a valid path(). More...
void | check ()
| Throws an exception if the path is not absolute. More...
Path | path () const
| Returns the path as supplied to the constructor or init(). More...

## Static Public Member Functions
static void | cleanup (SignalSafe, const char *path)
| Deletes the specified pid file if it contains this process's id. More...

## Detailed Description

A class for creating pid files.

Works with G::Root and G::Daemon so that the pid file can get created very late in a daemon startup sequence. Installs a signal handler so that the pid file gets deleted on process termination.

Usage:

G::PidFile pid_file ;
if( !path.empty() )
{ pid_file.init(path) ; pid_file.check() ; }
G::Root::init("nobody") ;
if( daemon ) G::Daemon::detach( pid_file ) ;
{ G::Root claim_root ; pid_file.commit() ; }

See also
  G::Daemon

Definition at line 55 of file gpidfile.h.

## Constructor & Destructor Documentation

G::PidFile::PidFile | ( | const Path & | pid_file_path | ) |
| explicit

Constructor.

The path should normally be an absolute path. Use commit() to actually create the file.

Definition at line 42 of file gpidfile.cpp.

G::PidFile::PidFile | ( |  | ) |

Default constructor.

Constructs a do-nothing object. Initialise with init().

Definition at line 31 of file gpidfile.cpp.

## Member Function Documentation

void G::PidFile::check | ( |  | ) |

Throws an exception if the path is not absolute.

The use of G::Daemon normally requires an absolute path because it may change the current working directory.

Definition at line 96 of file gpidfile.cpp.

void G::PidFile::cleanup | ( | SignalSafe | safe,
|  | const char * | path
| ) |  |
| static

Deletes the specified pid file if it contains this process's id.

Claims root privilege to read and delete the pid file (see G::Root).

This is not normally needed by client code since it is installed as a signal handler (see G::Cleanup) and called from the destructor.

Signal-safe, reentrant implementation.

Definition at line 81 of file gpidfile.cpp.

void G::PidFile::commit | ( |  | ) |

Creates the file and installs signal handlers to cleanup() the file on abnormal process termination.

Does nothing if no pid file path has been defined. Throws on error.

The caller is responsible for setting the file ownership and permissions by switching effecive user-id and umask.

Definition at line 102 of file gpidfile.cpp.

bool G::PidFile::committed | ( |  | ) | const

Returns true if commit() has been called with a valid path().

Definition at line 111 of file gpidfile.cpp.

void G::PidFile::init | ( | const Path & | pid_file_path | ) |

Used after default construction to make the object active.

Use commit() to actually create the file.

Definition at line 48 of file gpidfile.cpp.

G::Path G::PidFile::path | ( |  | ) | const

Returns the path as supplied to the constructor or init().

Definition at line 116 of file gpidfile.cpp.

The documentation for this class was generated from the following files:

- /tmp/slackrepo/SBo/slackrepo.S3SYfd/build_emailrelay/emailrelay-2.0.1/src/glib/gpidfile.h
- /tmp/slackrepo/SBo/slackrepo.S3SYfd/build_emailrelay/emailrelay-2.0.1/src/glib/gpidfile.cpp